#include <fcntl.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "tsync.h"
#include "tsync_trans.h"
#include "ddtsync.h"
#include "tsync_macros.h"

#include "tsync_hw.h"


/******************************************************************************/
/* Helper Functions ***********************************************************/
/******************************************************************************/

/*** Start of non-kts entry area [DO NOT MOVE OR ALTER THIS LINE] ***/

TSYNC_ERROR TSYNC_HW_getTemperature(TSYNC_BoardHandle handle,
                                     unsigned short* pTemp) {

    /* Create the objects the accessor call will reference */
    TSYNC_ERROR err;
    ITEM_ID     iid;
    uint32_t    actualOutLength;
    uint32_t    outPayload;
    
    
    iid.hnkid = HW_NONKTS_TEMPERATURE;
    
    CHECK_NOT_NULL(pTemp);
    
    
    /* Call the generic accessor */
    err = TSYNC_get(handle,
                    DEST_ID_HW_NONKTS,
                    iid,
                    NULL,
                    0,
                    (void*)&outPayload,
                    sizeof(outPayload),
                    &actualOutLength);
    
    // return the error if not success
    CHECK_SUCCESS(err);
    
    // fill in the output object
    *pTemp = outPayload ;
    
    return (TSYNC_SUCCESS);
    
} /* End TSYNC_HW_getTemperature */


/*** End of non-kts entry area [DO NOT MOVE OR ALTER THIS LINE] ***/
