
#ifndef _defined_TSYNC_QR_SERVICES_H
#define _defined_TSYNC_QR_SERVICES_H 1

/***************************************************************************
**  Module:     tsync_qr_services.h
**
**  Date:       09/08/09
**
**  Purpose:    Definitions and intermediate data structures
**              used by the driver and TSYNC API library routines
**
** (C) Copyright 2009 Spectracom Corporation  All rights reserved.
**
****************************************************************************
** Modifications:
**
**              09/08/2009 Creation
**
****************************************************************************/

#include "tsync_cs_services.h"

/******************************************************
**     Defines
******************************************************/

#define TSYNC_ID_QR                     0x2B
#define TSYNC_ID_QR_CA_OFFSET           0x00
#define TSYNC_ID_QR_CA_VALIDITY         0x01
#define TSYNC_ID_QR_CA_FORMAT           0x02
#define TSYNC_ID_QR_CA_LOCAL            0x03
#define TSYNC_ID_QR_CA_TIME_SCALE       0x04
#define TSYNC_ID_QR_CA_REF_ID           0x05
#define TSYNC_ID_QR_CA_NUM_INST         0x06

/******************************************************
**     Define Enumerations
******************************************************/

/******************************************************
**     Define Structures
******************************************************/

#define QR_VALUE_FIELDS                   \
    TSYNC_X(        uint32_t,   value)

#define QR_OFFSET_SET_CMD_FIELDS                   \
    TSYNC_X(        uint32_t,   inst)          \
    TSYNC_X(        int32_t,    offset)

#define QR_FORMAT_SET_CMD_FIELDS                   \
    TSYNC_X(        uint32_t,   inst)          \
    TSYNC_X(        QL_FMT,     format)

#define QR_LOCAL_SET_CMD_FIELDS         \
    TSYNC_X(        uint32_t,       inst)   \
    TSYNC_X( ML_DST_REF,     ref)                \
    TSYNC_X_STRUCT( ML_DST_POINT,    in)                \
    TSYNC_X_STRUCT( ML_DST_POINT,    out)                \
    TSYNC_X( uint32_t,    offset)                        \
    TSYNC_X( int32_t,        tz)

#define QR_TIME_SCALE_SET_CMD_FIELDS         \
    TSYNC_X(        uint32_t,           inst)   \
    TSYNC_X_STRUCT( ML_TIME_SCALE_OBJ,  scale)

#include "tsync_struct_define.h"

GEN_STRUCT(QR_VALUE)
GEN_STRUCT(QR_OFFSET_SET_CMD)
GEN_STRUCT(QR_FORMAT_SET_CMD)
GEN_STRUCT(QR_LOCAL_SET_CMD)
GEN_STRUCT(QR_TIME_SCALE_SET_CMD)

#include "tsync_struct_undef.h"

#endif  /* _defined_TSYNC_IR_SERVICES_H */
