#include "tsync_hw_nonkts_func.h"
#include "ddtsync.h"


/*** Start of non-kts function entry area [DO NOT MOVE OR ALTER THIS LINE] ***/

TSYNC_ERROR get_hw_temperature(TPRO_INSTANCE_T *hw,
                                uint8_t  *outPayload,
                                uint32_t maxOutLength,
                                uint32_t *actualResultBytes) {
                            
    const unsigned int outLength = sizeof(uint16_t);
    uint16_t readVal = 0;

    if (maxOutLength < outLength) {
        *actualResultBytes = 0;
        return TSYNC_DRV_BUFFER_OVERFLOW;
    }

    readVal = TSYNC_READ_REG(tsync_temperature_offset);
    
    memcpy(outPayload, &readVal, outLength);
    *actualResultBytes = outLength;

    return TSYNC_SUCCESS;
    
} /* end of get_hw_temperature */

/*** End of non-kts function entry area [DO NOT MOVE OR ALTER THIS LINE] ***/

TSYNC_ERROR hw_nonkts_get_trans(uint16_t iid,
                                TPRO_INSTANCE_T *hw,
                                uint8_t *inPayload,
                                uint32_t inLength,
                                uint8_t *outPayload,
                                uint32_t maxOutLength,
                                uint32_t *actualOutLength) {

    TSYNC_ERROR result = TSYNC_DRV_INVALID_INDEX;

    switch(iid) {

/*** Start of non-kts get_trans entry area [DO NOT MOVE OR ALTER THIS LINE] ***/

        case HW_NONKTS_TEMPERATURE:
            result =
                get_hw_temperature(hw,
                                    outPayload,
                                    maxOutLength,
                                    actualOutLength);
            break;

/*** End of non-kts get_trans entry area [DO NOT MOVE OR ALTER THIS LINE] ***/

        default:
            result = TSYNC_DRV_INVALID_INDEX;
            *actualOutLength = 0;
            break;
    };

    return result;

} /* end of hw_nonkts_get_trans */


TSYNC_ERROR hw_nonkts_set_trans(uint16_t iid,
                                TPRO_INSTANCE_T *hw,
                                uint8_t *inPayload,
                                uint32_t inLength,
                                uint8_t *outPayload,
                                uint32_t maxOutLength,
                                uint32_t *actualOutLength) {

    TSYNC_ERROR result = TSYNC_DRV_INVALID_INDEX;

    switch(iid) {

/*** Start of non-kts set_trans entry area [DO NOT MOVE OR ALTER THIS LINE] ***/

/*** End of non-kts set_trans entry area [DO NOT MOVE OR ALTER THIS LINE] ***/

        default:
            result = TSYNC_DRV_INVALID_INDEX;
            break;

    };

    *actualOutLength = 0;

    return result;

} /* end of hw_nonkts_set_trans */



